
# Those hardware-specific files should not be built for the host, even if
# most of them give no error or warning. The host has different implementations
obj-$(CONFIG_ARCH_LM32) += 	dev/simple_uart.o dev/console.o
obj-$(CONFIG_ARCH_RISCV) += 	dev/simple_uart.o dev/console.o

sdbfs_swap_bytes-$(CONFIG_ARCH_LM32) =
sdbfs_swap_bytes-$(CONFIG_ARCH_RISCV) = -e

obj-$(CONFIG_EMBEDDED_NODE) += \
	dev/endpoint.o \
	dev/ep_pfilter.o \
	dev/minic.o \
	dev/syscon.o \
	dev/sfp.o \
	dev/devicelist.o \
	dev/rxts_calibrator.o \
	dev/flash.o \
	dev/gpio.o \
	dev/bb_spi.o \
	dev/bb_i2c.o \
	dev/spi_flash.o \
	dev/i2c_eeprom.o \
	dev/storage.o \
	dev/netif.o

obj-$(CONFIG_WR_NODE) += \
	dev/pps_gen.o

obj-$(CONFIG_TARGET_WR_SWITCH) += dev/timer-wrs.o dev/gpio.o
obj-$(CONFIG_PUTS_SYSLOG) += dev/puts-syslog.o

obj-$(CONFIG_DAC_LOG) += dev/dac_log.o
obj-$(CONFIG_W1) +=		dev/w1.o	dev/w1-hw.o	dev/w1-shell.o
obj-$(CONFIG_W1_EEPROM) +=	dev/w1-eeprom.o
obj-$(CONFIG_W1_TEMP) +=	dev/temp-w1.o dev/w1-temp.o

obj-$(CONFIG_TEMP_SENSORS) += dev/temperature.o
obj-$(CONFIG_TEMP_FAKE) += dev/temp-fake.o

obj-$(CONFIG_ETHERBONE) += dev/etherbone.o

# board specific dev
obj-$(CONFIG_TARGET_GENERIC_PHY_8BIT) += \

obj-$(CONFIG_TARGET_GENERIC_PHY_16BIT) += \

obj-$(CONFIG_TARGET_WR_SWITCH) += \

obj-$(CONFIG_TARGET_AFCZ) += \
				dev/clock_monitor.o \

obj-$(CONFIG_TARGET_SIS8300KU) += \

obj-$(CONFIG_TARGET_ERTM14) += \
				dev/24aa025.o \
				dev/74x595.o \
				dev/ad7888.o \
				dev/ad951x.o \
				dev/ad9520.o \
				dev/ad9910.o \
				dev/clock_monitor.o \
				dev/iuart.o \
				dev/ltc6950.o \
				dev/fine_pulse_generator.o \

obj-$(CONFIG_TARGET_PXIE_FMC) += \
				dev/24aa025.o \

# Filter rules are selected according to configuration, but we may
# have more than one. Note: the filename is reflected in symbol names,
# so they are hardwired in ../Makefile (and ../tools/pfilter-builder too)

dev/ep_pfilter.o: $(pfilter-y)

dev/storage.o: $(sdbfsimg-y)

$(pfilter-y): tools
	./tools/pfilter-builder include/generated/

$(sdbfsimg-y): tools
	./tools/gensdbfs $(sdbfs_swap_bytes-y) -c include/generated/sdbfs-default.h tools/sdbfs tools/sdbfs-default.bin
